<?php
class ControllerExtensionPaymentMobilexpress extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('extension/payment/mobilexpress');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('setting/setting');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$this->model_setting_setting->editSetting('mobilexpress', $this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');

			$this->response->redirect($this->url->link('extension/extension', 'token=' . $this->session->data['token'] . '&type=payment', true));
		}

		$data['heading_title'] = $this->language->get('heading_title');

		$data['text_edit'] = $this->language->get('text_edit');
		$data['text_enabled'] = $this->language->get('text_enabled');
		$data['text_disabled'] = $this->language->get('text_disabled');
		$data['text_all_zones'] = $this->language->get('text_all_zones');
		
		$data['entry_module_title'] = $this->language->get('entry_module_title');
		$data['entry_MerchantCode'] = $this->language->get('entry_MerchantCode');
		$data['entry_Authorization'] = $this->language->get('entry_Authorization');
		$data['entry_islemTipi'] = $this->language->get('entry_islemTipi');
		$data['entry_paymentInstruments'] = $this->language->get('entry_paymentInstruments');
		$data['entry_viewType'] = $this->language->get('entry_viewType');
		$data['entry_designType'] = $this->language->get('entry_designType');
		$data['entry_UseLoyaltyPoints'] = $this->language->get('entry_UseLoyaltyPoints');
		$data['entry_Use3DSecure'] = $this->language->get('entry_Use3DSecure');
		$data['entry_CardSave'] = $this->language->get('entry_CardSave');
		$data['entry_RequestOTP'] = $this->language->get('entry_RequestOTP');
		$data['entry_UseInstallment'] = $this->language->get('entry_UseInstallment');
		$data['entry_CardSave_PrepaymentOptional'] = $this->language->get('entry_CardSave_PrepaymentOptional');
		$data['entry_CardSave_PrepaymentMandatory'] = $this->language->get('entry_CardSave_PrepaymentMandatory');
		$data['entry_CardSave_PostPayment'] = $this->language->get('entry_CardSave_PostPayment');
		$data['entry_CardSave_kapali'] = $this->language->get('entry_CardSave_kapali');
		$data['entry_parcali_odeme'] = $this->language->get('entry_parcali_odeme');
		$data['entry_no'] = $this->language->get('entry_no');
		$data['entry_yes'] = $this->language->get('entry_yes');
		$data['entry_optional'] = $this->language->get('entry_optional');
		$data['entry_zorunlu'] = $this->language->get('entry_zorunlu');
		$data['entry_cvv_onay'] = $this->language->get('entry_cvv_onay');
		
		$data['entry_paymentExtraConsent1'] = $this->language->get('entry_paymentExtraConsent1');
		$data['entry_paymentExtraConsent2'] = $this->language->get('entry_paymentExtraConsent2');
		$data['entry_cardSaveExtraConsent'] = $this->language->get('entry_cardSaveExtraConsent');

		$data['entry_order_status'] = $this->language->get('entry_order_status');
		$data['entry_order_status_payment'] = $this->language->get('entry_order_status_payment');
		$data['entry_order_failed_status_payment'] = $this->language->get('entry_order_failed_status_payment');
		

		$data['entry_total'] = $this->language->get('entry_total');
		$data['entry_geo_zone'] = $this->language->get('entry_geo_zone');
		$data['entry_status'] = $this->language->get('entry_status');
		$data['entry_sort_order'] = $this->language->get('entry_sort_order');

		$data['help_total'] = $this->language->get('help_total');

		$data['button_save'] = $this->language->get('button_save');
		$data['button_cancel'] = $this->language->get('button_cancel');

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'token=' . $this->session->data['token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_extension'),
			'href' => $this->url->link('extension/extension', 'token=' . $this->session->data['token'] . '&type=payment', true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('extension/payment/mobilexpress', 'token=' . $this->session->data['token'], true)
		);

		$data['action'] = $this->url->link('extension/payment/mobilexpress', 'token=' . $this->session->data['token'], true);
		$data['cancel'] = $this->url->link('extension/extension', 'token=' . $this->session->data['token'] . '&type=payment', true);

		if (isset($this->request->post['mobilexpress_module_title'])) {
			$data['mobilexpress_module_title'] = $this->request->post['mobilexpress_module_title'];
		} else {
			$data['mobilexpress_module_title'] = $this->config->get('mobilexpress_module_title');
		}
		
		if(!$data['mobilexpress_module_title']){
			$data['mobilexpress_module_title'] = "Kartla Ödeme";
		}
		

		if (isset($this->request->post['mobilexpress_MerchantCode'])) {
			$data['mobilexpress_MerchantCode'] = $this->request->post['mobilexpress_MerchantCode'];
		} else {
			$data['mobilexpress_MerchantCode'] = $this->config->get('mobilexpress_MerchantCode');
		}
		
		if (isset($this->request->post['mobilexpress_AuthorizationTest'])) {
			$data['mobilexpress_AuthorizationTest'] = $this->request->post['mobilexpress_AuthorizationTest'];
		} else {
			$data['mobilexpress_AuthorizationTest'] = $this->config->get('mobilexpress_AuthorizationTest');
		}
				
		if (isset($this->request->post['mobilexpress_AuthorizationLive'])) {
			$data['mobilexpress_AuthorizationLive'] = $this->request->post['mobilexpress_AuthorizationLive'];
		} else {
			$data['mobilexpress_AuthorizationLive'] = $this->config->get('mobilexpress_AuthorizationLive');
		}
		
		if (isset($this->request->post['mobilexpress_islemTipi'])) {
			$data['mobilexpress_islemTipi'] = $this->request->post['mobilexpress_islemTipi'];
		} else {
			$data['mobilexpress_islemTipi'] = $this->config->get('mobilexpress_islemTipi');
		}
		
		if (isset($this->request->post['mobilexpress_NewCard'])) {
			$data['mobilexpress_NewCard'] = $this->request->post['mobilexpress_NewCard'];
		} else {
			$data['mobilexpress_NewCard'] = $this->config->get('mobilexpress_NewCard');
		}
		
		if (isset($this->request->post['mobilexpress_InstantLoan'])) {
			$data['mobilexpress_InstantLoan'] = $this->request->post['mobilexpress_InstantLoan'];
		} else {
			$data['mobilexpress_InstantLoan'] = $this->config->get('mobilexpress_InstantLoan');
		}
		
		if (isset($this->request->post['mobilexpress_BKMExpress'])) {
			$data['mobilexpress_BKMExpress'] = $this->request->post['mobilexpress_BKMExpress'];
		} else {
			$data['mobilexpress_BKMExpress'] = $this->config->get('mobilexpress_BKMExpress');
		}
 
 		if (isset($this->request->post['mobilexpress_GarantiPay'])) {
			$data['mobilexpress_GarantiPay'] = $this->request->post['mobilexpress_GarantiPay'];
		} else {
			$data['mobilexpress_GarantiPay'] = $this->config->get('mobilexpress_GarantiPay');
		}
		
		if (isset($this->request->post['mobilexpress_MaximumMobil'])) {
			$data['mobilexpress_MaximumMobil'] = $this->request->post['mobilexpress_MaximumMobil'];
		} else {
			$data['mobilexpress_MaximumMobil'] = $this->config->get('mobilexpress_MaximumMobil');
		}
		
		if (isset($this->request->post['mobilexpress_DirectWireTransfer'])) {
			$data['mobilexpress_DirectWireTransfer'] = $this->request->post['mobilexpress_DirectWireTransfer'];
		} else {
			$data['mobilexpress_DirectWireTransfer'] = $this->config->get('mobilexpress_DirectWireTransfer');
		}
		
		
		
		if (isset($this->request->post['mobilexpress_UseLoyaltyPoints'])) {
			$data['mobilexpress_UseLoyaltyPoints'] = $this->request->post['mobilexpress_UseLoyaltyPoints'];
		} else {
			$data['mobilexpress_UseLoyaltyPoints'] = $this->config->get('mobilexpress_UseLoyaltyPoints');
		}
		
		if (isset($this->request->post['mobilexpress_Use3DSecure'])) {
			$data['mobilexpress_Use3DSecure'] = $this->request->post['mobilexpress_Use3DSecure'];
		} else {
			$data['mobilexpress_Use3DSecure'] = $this->config->get('mobilexpress_Use3DSecure');
		}
		
		if (isset($this->request->post['mobilexpress_CardSave'])) {
			$data['mobilexpress_CardSave'] = $this->request->post['mobilexpress_CardSave'];
		} else {
			$data['mobilexpress_CardSave'] = $this->config->get('mobilexpress_CardSave');
		}
		
		if (isset($this->request->post['mobilexpress_RequestOTP'])) {
			$data['mobilexpress_RequestOTP'] = $this->request->post['mobilexpress_RequestOTP'];
		} else {
			$data['mobilexpress_RequestOTP'] = $this->config->get('mobilexpress_RequestOTP');
		}
		
		 
		if (isset($this->request->post['mobilexpress_UseInstallment'])) {
			$data['mobilexpress_UseInstallment'] = $this->request->post['mobilexpress_UseInstallment'];
		} else {
			$data['mobilexpress_UseInstallment'] = $this->config->get('mobilexpress_UseInstallment');
		}
		
		if (isset($this->request->post['mobilexpress_CVVOnay'])) {
			$data['mobilexpress_CVVOnay'] = $this->request->post['mobilexpress_CVVOnay'];
		} else {
			$data['mobilexpress_CVVOnay'] = $this->config->get('mobilexpress_CVVOnay');
		}
		
		if (isset($this->request->post['mobilexpress_partialPayment'])) {
			$data['mobilexpress_partialPayment'] = $this->request->post['mobilexpress_partialPayment'];
		} else {
			$data['mobilexpress_partialPayment'] = $this->config->get('mobilexpress_partialPayment');
		}
		
		if (isset($this->request->post['mobilexpress_paymentExtraConsent1'])) {
			$data['mobilexpress_paymentExtraConsent1'] = $this->request->post['mobilexpress_paymentExtraConsent1'];
		} else {
			$data['mobilexpress_paymentExtraConsent1'] = $this->config->get('mobilexpress_paymentExtraConsent1');
		}
		
		if (isset($this->request->post['mobilexpress_paymentExtraConsent2'])) {
			$data['mobilexpress_paymentExtraConsent2'] = $this->request->post['mobilexpress_paymentExtraConsent2'];
		} else {
			$data['mobilexpress_paymentExtraConsent2'] = $this->config->get('mobilexpress_paymentExtraConsent2');
		}
		
		if (isset($this->request->post['mobilexpress_cardSaveExtraConsent'])) {
			$data['mobilexpress_cardSaveExtraConsent'] = $this->request->post['mobilexpress_cardSaveExtraConsent'];
		} else {
			$data['mobilexpress_cardSaveExtraConsent'] = $this->config->get('mobilexpress_cardSaveExtraConsent');
		}
		
		 
		
		if (isset($this->request->post['mobilexpress_total'])) {
			$data['mobilexpress_total'] = $this->request->post['mobilexpress_total'];
		} else {
			$data['mobilexpress_total'] = $this->config->get('mobilexpress_total');
		}
		if(!$data['mobilexpress_total']){
			$data['mobilexpress_total'] = 0;
		}

		if (isset($this->request->post['mobilexpress_order_status_id'])) {
			$data['mobilexpress_order_status_id'] = $this->request->post['mobilexpress_order_status_id'];
		} else {
			$data['mobilexpress_order_status_id'] = $this->config->get('mobilexpress_order_status_id');
		}
		
		if (isset($this->request->post['mobilexpress_payment_order_status_id'])) {
			$data['mobilexpress_payment_order_status_id'] = $this->request->post['mobilexpress_payment_order_status_id'];
		} else {
			$data['mobilexpress_payment_order_status_id'] = $this->config->get('mobilexpress_payment_order_status_id');
		}
		
		if (isset($this->request->post['mobilexpress_failed_order_status_id'])) {
			$data['mobilexpress_failed_order_status_id'] = $this->request->post['mobilexpress_failed_order_status_id'];
		} else {
			$data['mobilexpress_failed_order_status_id'] = $this->config->get('mobilexpress_failed_order_status_id');
		}


		$this->load->model('localisation/order_status');

		$data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();

		if (isset($this->request->post['mobilexpress_geo_zone_id'])) {
			$data['mobilexpress_geo_zone_id'] = $this->request->post['mobilexpress_geo_zone_id'];
		} else {
			$data['mobilexpress_geo_zone_id'] = $this->config->get('mobilexpress_geo_zone_id');
		}

		$this->load->model('localisation/geo_zone');

		$data['geo_zones'] = $this->model_localisation_geo_zone->getGeoZones();

		if (isset($this->request->post['mobilexpress_status'])) {
			$data['mobilexpress_status'] = $this->request->post['mobilexpress_status'];
		} else {
			$data['mobilexpress_status'] = $this->config->get('mobilexpress_status');
		}

		if (isset($this->request->post['mobilexpress_sort_order'])) {
			$data['mobilexpress_sort_order'] = $this->request->post['mobilexpress_sort_order'];
		} else {
			$data['mobilexpress_sort_order'] = $this->config->get('mobilexpress_sort_order');
		}

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('extension/payment/mobilexpress', $data));
	}

	protected function validate() {
		if (!$this->user->hasPermission('modify', 'extension/payment/mobilexpress')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}


		return !$this->error;
	}
}