<?php
class ControllerExtensionPaymentMobilexpress extends Controller {
	
	private function setcookieSameSite($name, $value, $expire, $path, $domain, $secure, $httponly) {

        if (PHP_VERSION_ID < 70300) {

            setcookie($name, $value, $expire, "$path; samesite=None", $domain, $secure, $httponly);
        }
        else {
            setcookie($name, $value, array(
                'expires' => $expire,
                'path' => $path,
                'domain' => $domain,
                'samesite' => 'None',
                'secure' => $secure,
                'httponly' => $httponly
            )
			);


        }
    }

     private function checkAndSetCookieSameSite(){

        $checkCookieNames = array('PHPSESSID','OCSESSID','default');

        foreach ($_COOKIE as $cookieName => $value) {
            foreach ($checkCookieNames as $checkCookieName){
                if (stripos($cookieName,$checkCookieName) === 0) {
                    $this->setcookieSameSite($cookieName,$_COOKIE[$cookieName], time() + 86400, "/", $_SERVER['SERVER_NAME'],true, true);
                }
            }
        }
    }
	
	
public function index() {
		
	$this->checkAndSetCookieSameSite();
	
	$this->load->model('checkout/order');
	$order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);
	$total = $this->currency->format($order_info['total'], $order_info['currency_code'], false, false);
		
$data = array(
  "orderId"=> $order_info['order_id'],
  "totalAmount"=> $total,
  "currency"=> "TRY",
  "uiDesignInfo"=> array(
    "viewType"=> "Compact",
    "designType"=> "4",
  ),
  "customerInfo"=> array(
  	"customerId"=>$order_info['customer_id'],
    "email"=> $order_info['email'],
    "name"=> $order_info['firstname']. " ".$order_info['lastname'],
    "phone"=> str_replace(" ","",substr($order_info['telephone'],-10)),
  ),
  "paymentInstrumentInfo"=> array(
    "card"=> array(
      "processType"=> "sales",
      "useInstallment"=> (bool)$this->config->get('mobilexpress_UseInstallment'),
      "useLoyaltyPoints"=> (bool)$this->config->get('mobilexpress_UseLoyaltyPoints'),
      "noAmex"=> true,
      "noDebitCard"=> true,
      "noForeignCard"=> true, 
    ),  
  ),
  "invoiceAddress"=> array(
    "contactName"=> !empty($order_info['payment_firstname']) ? $order_info['payment_firstname']. " ".$order_info['payment_lastname'] : "BELIRTILMEDI",
    "country"=> !empty($order_info['payment_country']) ? $order_info['payment_country'] : "BELIRTILMEDI",
	"city"=> !empty($order_info['payment_zone']) ? $order_info['payment_zone'] : "BELIRTILMEDI",
    "town"=> !empty($order_info['payment_city']) ? $order_info['payment_city'] : "BELIRTILMEDI",
    "address"=> !empty($order_info['payment_address_1']) ? $order_info['payment_address_1']." ".$order_info['payment_address_2'] : "BELIRTILMEDI",
    "postalCode"=> !empty($order_info['payment_postcode']) ? $order_info['payment_postcode'] : "10000",
  ),
  "deliveryAddress"=> array(
    "contactName"=> !empty($order_info['shipping_firstname']) ? $order_info['shipping_firstname']. " ".$order_info['shipping_lastname'] : ($order_info['payment_firstname']. " ".$order_info['payment_lastname']),
    "country"=> !empty($order_info['shipping_country']) ? $order_info['shipping_country'] : $order_info['payment_country'],
	"city"=> !empty($order_info['shipping_zone']) ? $order_info['shipping_zone'] : $order_info['payment_zone'],
    "town"=> !empty($order_info['shipping_city']) ? $order_info['shipping_city'] : $order_info['payment_city'],
    "address"=> !empty($order_info['shipping_address_1']) ? $order_info['shipping_address_1']." ".$order_info['shipping_address_2'] : ($order_info['payment_address_1']." ".$order_info['payment_address_2']),
    "postalCode"=> !empty($order_info['shipping_postcode']) ? $order_info['shipping_postcode'] : "10000",
  ),
  "returnUrl"=> $this->url->link('extension/payment/mobilexpress/result'),
  "notificationUrl"=> $this->url->link('extension/payment/mobilexpress/ipn'),
  "clientIp"=> getenv('REMOTE_ADDR'),
  "clientUserAgent"=> $_SERVER['HTTP_USER_AGENT'],
);
	
	foreach ($this->cart->getProducts() as $product) {
			$data['basketItems'][] = array(
				'name'     => htmlspecialchars($product['name']),
				'unitPrice'    => $this->currency->format($product['price'], $order_info['currency_code'], false, false),
				'quantity' => $product['quantity'],
				'criticalCategory' => "Other",
				'isParticipationBankingCompatible' => true,
			);
	}


			$digerTotal = $this->currency->format($order_info['total'] - $this->cart->getSubTotal(), $order_info['currency_code'], false, false);

			 if ($digerTotal > 0) {
				$data['basketItems'][] = array(
					'name'     => "Kargo ve Vergi Ücretleri",
					'unitPrice'    => $digerTotal,
					'quantity' => 1,
					'criticalCategory' => "Other",
					'isParticipationBankingCompatible' => true,
				);
			} 
	
	
	
	if($this->config->get('mobilexpress_CardSave') != "None"){
		
		$data["paymentInstruments"][] = "StoredCard";
		
		$data["paymentInstrumentInfo"]["card"]["storedCard"]["threeDSecureMode"] = $this->config->get('mobilexpress_Use3DSecure');
		$data["paymentInstrumentInfo"]["card"]["storedCard"]["customerIsLoggedIn"] = true;
		
		
		if($this->config->get('mobilexpress_RequestOTP') == "Mandatory"){
			$data["paymentInstrumentInfo"]["card"]["storedCard"]["verificationMethods"] = array("OTP");
		}
		if($this->config->get('mobilexpress_CVVOnay') == "1"){
			$data["paymentInstrumentInfo"]["card"]["storedCard"]["verificationMethods"] = array();
			$data["paymentInstrumentInfo"]["card"]["storedCard"]["verificationMethods"] = array("CVV");
		}
		
		if( $this->config->get('mobilexpress_RequestOTP') == "Mandatory" and $this->config->get('mobilexpress_CVVOnay') == "1"){
			$data["paymentInstrumentInfo"]["card"]["storedCard"]["verificationMethods"] = array();
			$data["paymentInstrumentInfo"]["card"]["storedCard"]["verificationMethods"] = array("OTPandCVV");
		}
	
	}
	
		if($this->config->get('mobilexpress_partialPayment') == "Optional"){
			$data["partialPayment"]["mode"] = "Optional";
			$data["partialPayment"]["maxCount"] = "3";
		}
	
	
		if($this->config->get('mobilexpress_NewCard') == "Evet"){
			
			$data["paymentInstruments"][] = "NewCard";
			$data["paymentInstrumentInfo"]["card"]["newCard"]["threeDSecureMode"] = $this->config->get('mobilexpress_Use3DSecure');
			$data["paymentInstrumentInfo"]["card"]["newCard"]["noCvv"] = false;
			$data["paymentInstrumentInfo"]["card"]["newCard"]["cardSaveOffer"] = $this->config->get('mobilexpress_CardSave');
			
			$data["paymentInstrumentInfo"]["card"]["newCard"]["cardConsents"]["cardSaveExtraConsent1"] = $this->config->get('mobilexpress_cardSaveExtraConsent');
			
			
		}
		if($this->config->get('mobilexpress_InstantLoan') == "Evet"){
			$data["paymentInstruments"][] = "InstantLoan";
			$data["paymentInstrumentInfo"]["instantLoan"] = array("bankAccountId"=> array());
		}
		if($this->config->get('mobilexpress_BKMExpress') == "Evet"){
			$data["paymentInstruments"][] = "BKMExpress";
			$data["paymentInstrumentInfo"]["card"]["bkmExpress"]["processType"] ="sales";
			
		}
		if($this->config->get('mobilexpress_GarantiPay') == "Evet"){
			$data["paymentInstruments"][] = "GarantiPay";
			$data["paymentInstrumentInfo"]["card"]["garantiPay"]["processType"] ="sales";
			
		}
		if($this->config->get('mobilexpress_MaximumMobil') == "Evet"){
			$data["paymentInstruments"][] = "MaximumMobil";
			$data["paymentInstrumentInfo"]["card"]["maximumMobil"]["processType"] ="sales";
			
		}
		
		if($this->config->get('mobilexpress_DirectWireTransfer') == "Evet"){
			$data["paymentInstruments"][] = "directWireTransfer";
			$data["paymentInstrumentInfo"]["directWireTransfer"] = array("bankAccountId"=> array());
			
		}
	
		$data["paymentConsents"]["paymentExtraConsent1"] = $this->config->get('mobilexpress_paymentExtraConsent1');
		$data["paymentConsents"]["paymentExtraConsent2"] = $this->config->get('mobilexpress_paymentExtraConsent2');
		
 	
	$data = json_encode($data);

	if($this->config->get('mobilexpress_islemTipi')){
		$url = "https://www.lidio.com/api/StartHostedPaymentProcess";
		$redir_url = "https://www.lidio.com/VPayment/VPayGateway.aspx";
		$MerchantCode = $this->config->get('mobilexpress_MerchantCode');
		$Authorization = $this->config->get('mobilexpress_AuthorizationLive');
	}else{
		$url = "https://test.lidio.com/api/StartHostedPaymentProcess";
		$redir_url = "https://test.lidio.com/VPayment/VPayGateway.aspx";
		$MerchantCode = $this->config->get('mobilexpress_MerchantCode');
		$Authorization = $this->config->get('mobilexpress_AuthorizationTest');
	}
$ch = curl_init();
curl_setopt($ch, CURLOPT_POST,1);
curl_setopt($ch, CURLOPT_URL,$url);
curl_setopt($ch, CURLOPT_SSL_VERIFYHOST,  FALSE);
curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
curl_setopt($ch, CURLOPT_TIMEOUT, 30);
curl_setopt($ch, CURLOPT_HTTPHEADER, array(
    "MerchantCode: ".$MerchantCode,
	"Authorization: ".$Authorization,
	"Content-Type: application/json",
  ));
	$result=curl_exec ($ch);
	$result = json_decode($result,true);
	
 	$resultCode = $result["result"];
	$resultMessage = $result["resultMessage"];
	$data = array();
 	
	if ($resultCode == 'Success'){
		$data["hostedUrl"] = $result["redirectURL"];
		if($this->config->get('mobilexpress_CardSave') == "PostPayment"){
			$this->session->data['redirectURL'] = $result["redirectURL"];
		}
	  }else{
		
		if ($resultCode == 'InvalidPhone') {
            $errorMessage = 'Geçersiz telefon numarası (5xx ile başlamalı ve 10 haneli olmalı)';
        } else if ($resultCode == 'InvalidEmail') {
            $errorMessage = 'Geçersiz email adresi';
        } else if ($resultCode == 'InvalidCustomerID') {
            $errorMessage = 'Geçersiz müşteri numarası';
        } else if ($resultCode == 'InvalidAmount') {
            $errorMessage = 'Geçersiz tutar';
        } else if ($resultCode == 'InvalidReturnURL') {
            $errorMessage = 'Geçersiz ReturnURL';
        } else if ($resultCode == 'AuthenticationError') {
            $errorMessage = 'Geçersiz api bilgileri (MerchantCode yada Authorization hatalı';
        } else if ($resultCode == 'ServerError') {
            $errorMessage = 'Sunucu tarafında sorun oluştu. Mobilexpress ile iletişime geçiniz';
        } else {
            $errorMessage = 'Bilinmeyen bir sorun oluştu. Mobilexpress ile iletişime geçiniz';
        }
		
		$data["errorMessage"] = $errorMessage. " - (".$resultCode." - ".$resultMessage.")";
 		$this->log->write('Mobilexpress Log: Time: '.date("Y-m-d H:i:s"). ' - OrderId:'.$this->session->data['order_id'].' - URL: '.$url.' - Result: ' . $resultCode. ' - ResultDetail: - ResultMessage: '.$resultMessage);
	}
		
		$data["checkout_url"] = $this->url->link('checkout/checkout');
		$data["redir_url"] = $redir_url;
		
		 $mobilexpress_tpl = 'extension/payment/mobilexpress';
		return $this->load->view($mobilexpress_tpl, $data);		
		 
	}

	 
	public function result() {
 	
	$OrderId = $_GET["OrderId"];
		
	if(isset($_GET["SystemTransId"])){
		$SystemTransId = $_GET["SystemTransId"];
		$data = array(
				  "systemTransId"=> $SystemTransId,
				  "orderId"=> $OrderId,
				  "clientIp"=> getenv('REMOTE_ADDR'),
				  "clientUserAgent"=> $_SERVER['HTTP_USER_AGENT'],
				);
		$status_uri = "GetHostedPaymentStatus";		
	}else{
		$data = array(
				  "orderId"=> $OrderId,
				  "clientIp"=> getenv('REMOTE_ADDR'),
				  "clientUserAgent"=> $_SERVER['HTTP_USER_AGENT'],
				);
		$status_uri = "GetHostedPartialPaymentStatus";		
	}	
 
	$data = json_encode($data);
 	
	if($this->config->get('mobilexpress_islemTipi')){
		$url = "https://www.lidio.com/api/".$status_uri;
		$MerchantCode = $this->config->get('mobilexpress_MerchantCodeLive');
		$Authorization = $this->config->get('mobilexpress_AuthorizationLive');
	}else{
		$url = "https://test.lidio.com/api/".$status_uri;
		$MerchantCode = $this->config->get('mobilexpress_MerchantCode');
		$Authorization = $this->config->get('mobilexpress_AuthorizationTest');
	}
	$ch = curl_init();
	curl_setopt($ch, CURLOPT_POST,1);
	curl_setopt($ch, CURLOPT_URL,$url);
	curl_setopt($ch, CURLOPT_SSL_VERIFYHOST,  FALSE);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
	curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
	curl_setopt($ch, CURLOPT_TIMEOUT, 30);
	curl_setopt($ch, CURLOPT_HTTPHEADER, array(
		 "MerchantCode: ".$MerchantCode,
		"Authorization: ".$Authorization,
		"Content-Type: application/json",
	  ));
	$result=curl_exec ($ch);
	$result = json_decode($result,TRUE);
  	
	if($result["paymentResult"] == "Success"){
		
 	$data = array();
	
	$data["SiparisTutar"] = number_format($result["processInfo"]["totalAmountRequested"],2,".","");
	$data["ToplamTutar"] = number_format($result["processInfo"]["totalAmountProcessed"],2,".","");
	$data["VadeFarki"] = number_format($data["ToplamTutar"]-$data["SiparisTutar"],2,".","");
	  	
 	  $this->load->model('checkout/order');
	  $order_id = $OrderId;
	  
		$this->db->query("UPDATE `" . DB_PREFIX . "order` SET total='".$data["ToplamTutar"]."' WHERE order_id = '".$order_id."'");
		$this->db->query("UPDATE `" . DB_PREFIX . "order_total` SET value = '".$data["ToplamTutar"]."', sort_order = '100' WHERE code='total' AND order_id = '" . $order_id . "'");
		$this->db->query("INSERT INTO `" . DB_PREFIX . "order_total` SET value = '".$data["VadeFarki"]."', title='Vade Farkı & Faiz', code='vade', order_id = '" . $order_id . "', sort_order = '99'");
		
		$this->model_checkout_order->addOrderHistory($order_id, $this->config->get('mobilexpress_order_status_id'));
		
		
	$instrumentType = array();	
	$paymentLogsss = array();
	foreach($result["paymentList"] as $paymentList){
		$data = array();	
	  $data["SystemTransId"] = $paymentList["systemTransId"];
	  $data["InstallmentCount"] = $paymentList["installmentCount"];
	  $data["OrderId"] = $paymentList["orderId"];
	  $data["BankaOnayKodu"] = $paymentList["acquirerResultDetail"]["pos"]["authCode"];
	  $data["OdemeYapilanPos"] = $paymentList["acquirerResultDetail"]["pos"]["posBankName"];
	  $data["POSID"] = $paymentList["acquirerResultDetail"]["pos"]["posId"];
	  $data["BankaTransId"] = $paymentList["acquirerResultDetail"]["pos"]["transId"];
	  $data["KartNumarasi"] = $paymentList["instrumentDetail"]["card"]["maskedCardNumber"];
	  $data["cardHolderNameFromBank"] = $paymentList["acquirerResultDetail"]["pos"]["cardHolderNameFromBank"];
	  
	  
	  $instrumentType[] = $paymentList["instrumentType"];
	  	  
	  if($data["InstallmentCount"]==0){
		  $data["odemeYontemi"] = "KREDI KARTI TEK ÇEKİM";
	  }else{
		  $data["odemeYontemi"] = "KREDI KARTI ".$data["InstallmentCount"]." TAKSİT";
	  }
	  
	  $paymentLog = "";
	  foreach($data as $Key=>$Value){
		  $paymentLog .=$Key ." : ".$Value."<br>";
	  }
	  
	  $paymentLogsss[] = $paymentLog;
	}
	$paymentLogsss = implode("<br><br>",$paymentLogsss);
	
	$this->model_checkout_order->addOrderHistory($order_id, $this->config->get('mobilexpress_order_status_id'), $paymentLogsss, false);
	
	if(!in_array("NewCard",$instrumentType)){
		unset($this->session->data['redirectURL']);
	}
 		
	  echo '<script>window.top.location.href = "' . $this->url->link('checkout/success') . '";</script>';
				  
	}else{
 	  
	  $error = "Ödeme başarısız. Lütfen yeniden deneyiniz. Hata mesajı: ".$result["result"]." - ".$result["resultDetail"]." - ".$result["paymentResult"];
	 
	  $this->log->write('Mobilexpress Log: Time: '.date("Y-m-d H:i:s"). ' - OrderId:'.$this->session->data['order_id'].' - URL: '.$url.' - Result: ' . $result["result"]. " - ResultDetail:".$result["resultDetail"]." - ResultMessage:".$result["resultMessage"]. " - PaymentResult:".$result["paymentResult"]);
	  
	  $this->session->data['error'] = $error;
	  $returnUrl = $this->url->link('checkout/checkout', 'error=' . $error);
	  echo '<script>window.top.location.href = "' . $returnUrl . '";</script>';
	}
		
	}
	
	public function ipn() {
		
		$this->load->model('checkout/order');
		
		$data = file_get_contents("php://input");
	  
	  if(!empty($data)){
		  	
		$this->log->write('Mobilexpress IPN Log: '.$data);
	  
	 	$result = json_decode($data,true);
		
		$orderId = $result["processInfo"]["orderId"];
		
		$fraudControlResult = array();
		$fraudControl = false;
		foreach($result["paymentList"] as $paymentList){
	  		if(isset($paymentList["fraudControlInfo"]["fraudControlResult"])){
				$fraudControlResult[] = $paymentList["fraudControlInfo"]["fraudControlResult"];
				$fraudControl = true;
			}
		}
		
	
		if(in_array("RiskNotDetected",$fraudControlResult)){
			$this->model_checkout_order->addOrderHistory($orderId, $this->config->get('mobilexpress_payment_order_status_id'),"",true);
		}elseif(in_array("RiskDetected",$fraudControlResult)){
			$this->model_checkout_order->addOrderHistory($orderId, $this->config->get('mobilexpress_failed_order_status_id'),"ÖDEME GÜVENLİK KONTROLÜNDEN GEÇEMEDİ. (FRAUD İPTALİ)",true);
		}elseif(in_array("InProcess",$fraudControlResult)){
			$this->model_checkout_order->addOrderHistory($orderId, $this->config->get('mobilexpress_order_status_id'),"FRAUD KONTROLÜ DEVAM EDİYOR.",true);
		}elseif(in_array("NotProcessed",$fraudControlResult)){
			$this->model_checkout_order->addOrderHistory($orderId, $this->config->get('mobilexpress_payment_order_status_id'),"",true);
		}else{
			if(!$fraudControl){
				if($result["paymentResult"] == "Success"){
					$this->model_checkout_order->addOrderHistory($orderId, $this->config->get('mobilexpress_payment_order_status_id'),"ÖDEMENİZ BAŞARILI OLMUŞTUR.",true);
				}
			}
		}
	  }
	 	die("OK");
	}
}
